package test;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;

import java.util.Map;

import org.openliberty.openaz.azapi.AzEntity;
import org.openliberty.openaz.azapi.AzResourceActionAssociation;
import org.openliberty.openaz.azapi.AzService;
import org.openliberty.openaz.azapi.constants.AzCategoryIdAction;
import org.openliberty.openaz.azapi.constants.AzCategoryIdResource;
import org.openliberty.openaz.azapi.constants.AzXacmlStrings;
import org.openliberty.openaz.pep.PepRequest;
import org.openliberty.openaz.pep.PepRequestFactory;
import org.openliberty.openaz.pep.PepResponse;
import test.TestUtils;

public class QueryTest {

	static TestUtils testUtils = new TestUtils();

    public static void main(String[] args) throws Exception {

        AzService azService =
            new org.openliberty.openaz.pdp.provider.SimpleConcreteService();
        PepRequestFactory pep = new PepRequestFactory(
        		"QueryPep", azService);

        Date now = new Date();

        HashMap<String, String> subject = 
        	new HashMap<String, String>();
        subject.put(
        	AzXacmlStrings.X_ATTR_SUBJECT_ID, "josh");
        subject.put(
        	AzXacmlStrings.X_ATTR_SUBJECT_AUTHN_LOC_AUTHENTICATION_METHOD,
                    "password");

        PepRequest pepRequest =
            pep.newQueryPepRequest(
        		subject, 
        		now, 
        		"actionsOnResource:foo", 
        		PepRequest.QUERY_TYPE.SIMPLE_RETURN_ALLOWED_RESULTS);

        PepResponse response = pepRequest.decide();

        while (response.next()) {

            System.out.println("Action=" + response.getAction() +
                               " Resource=" + response.getResource() +
                               " allowed=" + response.allowed());

            //Obligations are not there
        }

        pepRequest =
                pep.newQueryPepRequest(subject, now, "actionsOnResource:foo",
                                       PepRequest.QUERY_TYPE.VERBOSE);

        response = pepRequest.decide();

        while (response.next())

            System.out.println("Action=" + response.getAction() +
                               " Resource=" + response.getResource() +
                               " allowed=" + response.allowed());

        
        testUtils.logObligations(response);
        
    }


}
